#
#   - Time::HiRes -
#   This spec file was automatically generated by cpan2rpm [ver: 2.028]
#   The following arguments were used:
#       --spec-only '--packager=Stuart Raeburn <raeburn@loncapa.org>' --release=1.0.sles11.lc Time::HiRes
#   For more information on cpan2rpm please visit: http://perl.arix.com/
#

%define pkgname Time-HiRes
%define filelist %{pkgname}-%{version}-filelist
%define NVR %{pkgname}-%{version}-%{release}
%define maketest 1

name:      perl-Time-HiRes
summary:   Time-HiRes - High resolution alarm, sleep, gettimeofday, interval timers
version:   1.9719
release:   1.0.sles11.lc
vendor:    Jarkko Hietaniemi <jhi@iki.fi>
packager:  Stuart Raeburn <raeburn@loncapa.org>
license:   Artistic
group:     Applications/CPAN
url:       http://www.cpan.org
buildroot: %{_tmppath}/%{name}-%{version}-%(id -u -n)
prefix:    %(echo %{_prefix})
source:    http://search.cpan.org//CPAN/authors/id/J/JH/JHI/Time-HiRes-1.9719.tar.gz

%description
The `Time::HiRes' module implements a Perl interface to the
`usleep', `nanosleep', `ualarm', `gettimeofday', and
`setitimer'/`getitimer' system calls, in other words, high
resolution time and timers. See the the EXAMPLES entry elsewhere in this document section below and the
test scripts for usage; see your system documentation for the
description of the underlying `nanosleep' or `usleep', `ualarm',
`gettimeofday', and `setitimer'/`getitimer' calls.

If your system lacks `gettimeofday()' or an emulation of it you don't
get `gettimeofday()' or the one-argument form of `tv_interval()'.
If your system lacks all of `nanosleep()', `usleep()',
`select()', and `poll', you don't get `Time::HiRes::usleep()',
`Time::HiRes::nanosleep()', or `Time::HiRes::sleep()'.
If your system lacks both `ualarm()' and `setitimer()' you don't get
`Time::HiRes::ualarm()' or `Time::HiRes::alarm()'.

If you try to import an unimplemented function in the `use' statement
it will fail at compile time.

If your subsecond sleeping is implemented with `nanosleep()' instead
of `usleep()', you can mix subsecond sleeping with signals since
`nanosleep()' does not use signals.  This, however, is not portable,
and you should first check for the truth value of
`&Time::HiRes::d_nanosleep' to see whether you have nanosleep, and
then carefully read your `nanosleep()' C API documentation for any
peculiarities.

If you are using `nanosleep' for something else than mixing sleeping
with signals, give some thought to whether Perl is the tool you should
be using for work requiring nanosecond accuracies.

Remember that unless you are working on a *hard realtime* system,
any clocks and timers will be imprecise, especially so if you are working
in a pre-emptive multiuser system.  Understand the difference between
*wallclock time* and process time (in UNIX-like systems the sum of
*user* and *system* times).  Any attempt to sleep for X seconds will
most probably end up sleeping more than that, but don't be surpised
if you end up sleeping slightly less.

The following functions can be imported from this module.
No functions are exported by default.

=over 4

=item gettimeofday ()

In array context returns a two-element array with the seconds and
microseconds since the epoch.  In scalar context returns floating
seconds like `Time::HiRes::time()' (see below).

=item usleep ( $useconds )

Sleeps for the number of microseconds (millionths of a second)
specified.  Returns the number of microseconds actually slept.
Can sleep for more than one second, unlike the `usleep' system call.
Can also sleep for zero seconds, which often works like a *thread yield*.
See also `Time::HiRes::usleep()', `Time::HiRes::sleep()', and
`Time::HiRes::clock_nanosleep()'.

Do not expect usleep() to be exact down to one microsecond.

=item nanosleep ( $nanoseconds )

Sleeps for the number of nanoseconds (1e9ths of a second) specified.
Returns the number of nanoseconds actually slept (accurate only to
microseconds, the nearest thousand of them).  Can sleep for more than
one second.  Can also sleep for zero seconds, which often works like
a *thread yield*.  See also `Time::HiRes::sleep()',
`Time::HiRes::usleep()', and `Time::HiRes::clock_nanosleep()'.

Do not expect nanosleep() to be exact down to one nanosecond.
Getting even accuracy of one thousand nanoseconds is good.

=item ualarm ( $useconds [, $interval_useconds ] )

Issues a `ualarm' call; the `$interval_useconds' is optional and
will be zero if unspecified, resulting in `alarm'-like behaviour.

Returns the remaining time in the alarm in microseconds, or `undef'
if an error occurred.

ualarm(0) will cancel an outstanding ualarm().

Note that the interaction between alarms and sleeps is unspecified.

=item tv_interval 

tv_interval ( $ref_to_gettimeofday [, $ref_to_later_gettimeofday] )

Returns the floating seconds between the two times, which should have
been returned by `gettimeofday()'. If the second argument is omitted,
then the current time is used.

=item time ()

Returns a floating seconds since the epoch. This function can be
imported, resulting in a nice drop-in replacement for the `time'
provided with core Perl; see the the EXAMPLES entry elsewhere in this document below.

NOTE 1: This higher resolution timer can return values either less
or more than the core `time()', depending on whether your platform
rounds the higher resolution timer values up, down, or to the nearest second
to get the core `time()', but naturally the difference should be never
more than half a second.  See also the clock_getres entry elsewhere in this document, if available
in your system.

NOTE 2: Since Sunday, September 9th, 2001 at 01:46:40 AM GMT, when
the `time()' seconds since epoch rolled over to 1_000_000_000, the
default floating point format of Perl and the seconds since epoch have
conspired to produce an apparent bug: if you print the value of
`Time::HiRes::time()' you seem to be getting only five decimals, not
six as promised (microseconds).  Not to worry, the microseconds are
there (assuming your platform supports such granularity in the first
place).  What is going on is that the default floating point format of
Perl only outputs 15 digits.  In this case that means ten digits
before the decimal separator and five after.  To see the microseconds
you can use either `printf'/`sprintf' with `"%.6f"', or the
`gettimeofday()' function in list context, which will give you the
seconds and microseconds as two separate values.

=item sleep ( $floating_seconds )

Sleeps for the specified amount of seconds.  Returns the number of
seconds actually slept (a floating point value).  This function can
be imported, resulting in a nice drop-in replacement for the `sleep'
provided with perl, see the the EXAMPLES entry elsewhere in this document below.

Note that the interaction between alarms and sleeps is unspecified.

=item alarm ( $floating_seconds [, $interval_floating_seconds ] )

The `SIGALRM' signal is sent after the specified number of seconds.
Implemented using `setitimer()' if available, `ualarm()' if not.
The `$interval_floating_seconds' argument is optional and will be
zero if unspecified, resulting in `alarm()'-like behaviour.  This
function can be imported, resulting in a nice drop-in replacement for
the `alarm' provided with perl, see the the EXAMPLES entry elsewhere in this document below.

Returns the remaining time in the alarm in seconds, or `undef'
if an error occurred.

NOTE 1: With some combinations of operating systems and Perl
releases `SIGALRM' restarts `select()', instead of interrupting it.
This means that an `alarm()' followed by a `select()' may together
take the sum of the times specified for the the `alarm()' and the
`select()', not just the time of the `alarm()'.

Note that the interaction between alarms and sleeps is unspecified.

=item setitimer ( $which, $floating_seconds [, $interval_floating_seconds ] )

Start up an interval timer: after a certain time, a signal ($which) arrives,
and more signals may keep arriving at certain intervals.  To disable
an "itimer", use `$floating_seconds' of zero.  If the
`$interval_floating_seconds' is set to zero (or unspecified), the
timer is disabled after the next delivered signal.

Use of interval timers may interfere with `alarm()', `sleep()',
and `usleep()'.  In standard-speak the "interaction is unspecified",
which means that *anything* may happen: it may work, it may not.

In scalar context, the remaining time in the timer is returned.

In list context, both the remaining time and the interval are returned.

There are usually three or four interval timers (signals) available: the
`$which' can be `ITIMER_REAL', `ITIMER_VIRTUAL', `ITIMER_PROF', or
`ITIMER_REALPROF'.  Note that which ones are available depends: true
UNIX platforms usually have the first three, but only Solaris seems to
have `ITIMER_REALPROF' (which is used to profile multithreaded programs).
Win32 unfortunately does not haveinterval timers.

`ITIMER_REAL' results in `alarm()'-like behaviour.  Time is counted in
*real time*; that is, wallclock time.  `SIGALRM' is delivered when
the timer expires.

`ITIMER_VIRTUAL' counts time in (process) *virtual time*; that is,
only when the process is running.  In multiprocessor/user/CPU systems
this may be more or less than real or wallclock time.  (This time is
also known as the *user time*.)  `SIGVTALRM' is delivered when the
timer expires.

`ITIMER_PROF' counts time when either the process virtual time or when
the operating system is running on behalf of the process (such as I/O).
(This time is also known as the *system time*.)  (The sum of user
time and system time is known as the *CPU time*.)  `SIGPROF' is
delivered when the timer expires.  `SIGPROF' can interrupt system calls.

The semantics of interval timers for multithreaded programs are
system-specific, and some systems may support additional interval
timers.  For example, it is unspecified which thread gets the signals.
See your `setitimer()' documentation.

=item getitimer ( $which )

Return the remaining time in the interval timer specified by `$which'.

In scalar context, the remaining time is returned.

In list context, both the remaining time and the interval are returned.
The interval is always what you put in using `setitimer()'.

=item clock_gettime ( $which )

Return as seconds the current value of the POSIX high resolution timer
specified by `$which'.  All implementations that support POSIX high
resolution timers are supposed to support at least the `$which' value
of `CLOCK_REALTIME', which is supposed to return results close to the
results of `gettimeofday', or the number of seconds since 00:00:00:00
January 1, 1970 Greenwich Mean Time (GMT).  Do not assume that
CLOCK_REALTIME is zero, it might be one, or something else.
Another potentially useful (but not available everywhere) value is
`CLOCK_MONOTONIC', which guarantees a monotonically increasing time
value (unlike time() or gettimeofday(), which can be adjusted).
See your system documentation for other possibly supported values.

=item clock_getres ( $which )

Return as seconds the resolution of the POSIX high resolution timer
specified by `$which'.  All implementations that support POSIX high
resolution timers are supposed to support at least the `$which' value
of `CLOCK_REALTIME', see the clock_gettime entry elsewhere in this document.

=item clock_nanosleep ( $which, $nanoseconds, $flags = 0)

Sleeps for the number of nanoseconds (1e9ths of a second) specified.
Returns the number of nanoseconds actually slept.  The $which is the
"clock id", as with clock_gettime() and clock_getres().  The flags
default to zero but `TIMER_ABSTIME' can specified (must be exported
explicitly) which means that `$nanoseconds' is not a time interval
(as is the default) but instead an absolute time.  Can sleep for more
than one second.  Can also sleep for zero seconds, which often works
like a *thread yield*.  See also `Time::HiRes::sleep()',
`Time::HiRes::usleep()', and `Time::HiRes::nanosleep()'.

Do not expect clock_nanosleep() to be exact down to one nanosecond.
Getting even accuracy of one thousand nanoseconds is good.

=item clock()

Return as seconds the *process time* (user + system time) spent by
the process since the first call to clock() (the definition is not
"since the start of the process", though if you are lucky these times
may be quite close to each other, depending on the system).  What this
means is that you probably need to store the result of your first call
to clock(), and subtract that value from the following results of clock().

The time returned also includes the process times of the terminated
child processes for which wait() has been executed.  This value is
somewhat like the second value returned by the times() of core Perl,
but not necessarily identical.  Note that due to backward
compatibility limitations the returned value may wrap around at about
2147 seconds or at about 36 minutes.

=item stat

=item stat FH

=item stat EXPR

As the stat entry in the perlfunc manpage but with the access/modify/change file timestamps
in subsecond resolution, if the operating system and the filesystem
both support such timestamps.  To override the standard stat():

    use Time::HiRes qw(stat);

Test for the value of &Time::HiRes::d_hires_stat to find out whether
the operating system supports subsecond file timestamps: a value
larger than zero means yes. There are unfortunately no easy
ways to find out whether the filesystem supports such timestamps.
UNIX filesystems often do; NTFS does; FAT doesn't (FAT timestamp
granularity is two seconds).

A zero return value of &Time::HiRes::d_hires_stat means that
Time::HiRes::stat is a no-op passthrough for CORE::stat(),
and therefore the timestamps will stay integers.  The same
thing will happen if the filesystem does not do subsecond timestamps,
even if the &Time::HiRes::d_hires_stat is non-zero.

In any case do not expect nanosecond resolution, or even a microsecond
resolution.  Also note that the modify/access timestamps might have
different resolutions, and that they need not be synchronized, e.g.
if the operations are

    write
    stat # t1
    read
    stat # t2

the access time stamp from t2 need not be greater-than the modify
time stamp from t1: it may be equal or *less*.

=back

#
# This package was generated automatically with the cpan2rpm
# utility.  To get this software or for more information
# please visit: http://perl.arix.com/
#

%prep
%setup -q -n %{pkgname}-%{version} 
chmod -R u+w %{_builddir}/%{pkgname}-%{version}

%build
grep -rsl '^#!.*perl' . |
grep -v '.bak$' |xargs --no-run-if-empty \
%__perl -MExtUtils::MakeMaker -e 'MY->fixin(@ARGV)'
CFLAGS="$RPM_OPT_FLAGS"
%{__perl} Makefile.PL `%{__perl} -MExtUtils::MakeMaker -e ' print qq|PREFIX=%{buildroot}%{_prefix}| if \$ExtUtils::MakeMaker::VERSION =~ /5\.9[1-6]|6\.0[0-5]/ '`
%{__make} 
%if %maketest
%{__make} test
%endif

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%{makeinstall} `%{__perl} -MExtUtils::MakeMaker -e ' print \$ExtUtils::MakeMaker::VERSION <= 6.05 ? qq|PREFIX=%{buildroot}%{_prefix}| : qq|DESTDIR=%{buildroot}| '`

cmd=/usr/share/spec-helper/compress_files
[ -x $cmd ] || cmd=/usr/lib/rpm/brp-compress
[ -x $cmd ] && $cmd

# SuSE Linux
if [ -e /etc/SuSE-release -o -e /etc/UnitedLinux-release ]
then
    %{__mkdir_p} %{buildroot}/var/adm/perl-modules
    %{__cat} `find %{buildroot} -name "perllocal.pod"`  \
        | %{__sed} -e s+%{buildroot}++g                 \
        > %{buildroot}/var/adm/perl-modules/%{name}
fi

# remove special files
find %{buildroot} -name "perllocal.pod" \
    -o -name ".packlist"                \
    -o -name "*.bs"                     \
    |xargs -i rm -f {}

# no empty directories
find %{buildroot}%{_prefix}             \
    -type d -depth                      \
    -exec rmdir {} \; 2>/dev/null

%{__perl} -MFile::Find -le '
    find({ wanted => \&wanted, no_chdir => 1}, "%{buildroot}");
    print "%doc  TODO hints Changes README fallback";
    for my $x (sort @dirs, @files) {
        push @ret, $x unless indirs($x);
        }
    print join "\n", sort @ret;

    sub wanted {
        return if /auto$/;

        local $_ = $File::Find::name;
        my $f = $_; s|^\Q%{buildroot}\E||;
        return unless length;
        return $files[@files] = $_ if -f $f;

        $d = $_;
        /\Q$d\E/ && return for reverse sort @INC;
        $d =~ /\Q$_\E/ && return
            for qw|/etc %_prefix/man %_prefix/bin %_prefix/share|;

        $dirs[@dirs] = $_;
        }

    sub indirs {
        my $x = shift;
        $x =~ /^\Q$_\E\// && $x ne $_ && return 1 for @dirs;
        }
    ' > %filelist

[ -z %filelist ] && {
    echo "ERROR: empty %files listing"
    exit -1
    }

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files -f %filelist
%defattr(-,root,root)

%changelog
* Thu Dec 31 2009 Stuart Raeburn <raeburn at loncapa.org>
- Initial build.
